//+------------------------------------------------------------------+
//|                                              Data structures.mqh |
//|                                                  Roman Martynyuk |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Roman Martynyuk"
#property link      "http://www.mql5.com"
//    ,   
struct TPoints
  {
   double            ValuePoints[];  //   
   int               IndexPoints[];  //   
   int               NumPoints;      //   
  };
//     
class TWave
  {
public:
   string            Name;            //  
   string            Formula;         //   (1-2-3-4-5, <1-2-3  ..)
   int               Level;           //  () 
   double            ValueVertex[6];  //   
   int               IndexVertex[6];  //   
  };
//     
class TNode:public CObject
  {
public:
   CArrayObj        *Child;    //    
   TWave            *Wave;     // ,    
   string            Text;     //   
   TNode            *Add(string Text,TWave *Wave=NULL) //     
     {
      TNode *Node=new TNode;
      Node.Child=new CArrayObj;
      Node.Text =Text;
      Node.Wave=Wave;
      Child.Add(Node);
      return(Node);
     }
  };
//      
struct TWaveDescription
  {
   string            NameWave;    //  
   int               NumWave;     //    
   string            Subwaves[6]; //     
  };
//         
class TLabel:public CObject
  {
public:
   double            Value;  //  
   int               Level;  //  
   string            Text;   //  
  };
//        
class TZigzag:public CObject
  {
public:
   CArrayInt        *IndexVertex;    //   
   CArrayDouble     *ValueVertex;    //   
  };
//       ,    
class TNodeInfo:CObject
  {
public:
   int               IndexStart,IndexFinish;  //    
   double            ValueStart,ValueFinish;  //     
   string            Subwaves;                //     
   TNode            *Node;                    // ,     
  };
//+------------------------------------------------------------------+
